/*
 * IRC - Internet Relay Chat, include/s_bdd.h
 * Copyright (C) 1999 IRC-Hispano.org - ESNET - jcea & savage
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef S_BDD_H
#define S_BDD_H

#include "struct.h"

#if defined(BDD)
#define ESNET_BDD         'a'
#define ESNET_BDD_END     'z'
#define ESNET_NICKDB      'n'
#define ESNET_CLONESDB    'i'

#define BDD_OPERDB        'o'
#define BDD_CHANDB        'c'
#define BDD_BOTSDB        'b'
#define BDD_IPVIRTUALDB   'v'
#define BDD_IPVIRTUAL2DB  'w'
#define BDD_CHANDB_OLD    'z'

/* Para las features de los pseudoBOTS */
#define BDD_CHANSERV      "ChanServ"
#define BDD_NICKSERV      "NickServ"
#define BDD_OPERSERV      "OperServ"
#define BDD_NEWSSERV      "NewsServ"
#define BDD_VHOSTSERV      "VhostServ"
#define BDD_CANAL_NOTIF_SOCKS  "SocksChannel"

struct db_reg {
  char *clave;
  char *valor;
  struct db_reg *next;
};
#endif /* BDD */

#ifdef BDD
void reload_db(void);
void initdb(void);
struct DB_nick *find_db_nick(char *nick);
void tx_num_serie_dbs(aClient *cptr);
int m_db(aClient *cptr, aClient *sptr, int parc, char *parv[]);

void tea(unsigned int v[], unsigned int k[], unsigned int x[]);
struct db_reg *db_buscar_registro(unsigned char tabla, char *clave);
int db_es_miembro(unsigned char tabla, char *clave, char *subcadena);
int db_es_residente(unsigned char tabla);
unsigned int db_num_serie(unsigned char tabla);
unsigned int db_cuantos(unsigned char tabla);

#if defined(BDD_MMAP)
int db_persistent_hit(void);
void db_persistent_commit(void);
#endif

int m_dbq(aClient *cptr, aClient *sptr, int parc, char *parv[]);
#endif

/* -- mman.h no contiene algunas definicieones en plataformas antiguas -- */
#ifndef MAP_FAILED
#define MAP_FAILED ((void *) -1)
#endif
#ifndef MAP_NORESERVE
#define MAP_NORESERVE 0
#endif
/* -- savage 1999/11/19 -- */

#endif /* S_BDD_H */
